"use strict"

let basePush =  require('./basePush');
let types = require('./types');
let exceptions = require('./exceptions');
let queueNames = require('./queueNames');

let BasePush = basePush.BasePush;
let PatientPromoAndroidPushObj = types.PatientPromoAndroidPushObj;
let PushValidationException = exceptions.PushValidationException;


class PatientPromoAndroidPush extends BasePush {
    constructor(request, config, appName) {
        super(request, config, appName);
        this.comm_app_name = 'fabric-droid';
        this.pushNotification = new PatientPromoAndroidPushObj();
        this.pushNotification.service = appName;
        this.queueName = queueNames.sendPatientPromoPushQueue;
    }

    validateFilters(inputDict) {
        this.validatePushRelationKeys(inputDict);
    }

    validatePushType(pushType) {
        let allowed_types = []
        if (allowed_types.indexOf(pushType) == -1)
            throw new PushValidationException("Invalid push notification type");
    }
}

module.exports = {
    PatientPromoAndroidPush: PatientPromoAndroidPush
}
