"use strict"

let DateTime = require('node-datetime');

class GenericTransactionalSms{
  constructor(){
    this.id = null;
    this.reference_id = null;
    this.reference_type = null;
    this.name = null;
    this.mobile = null;
    this.message_text = null;
    this.message_type = null;
    this.delivery_time = null;
    this.status = null;
    this.failure_reason = null;
    this.attempt = null;
    this.operator = null;
    this.operator_reply = null;
    this.operator_code = null;
    this.created_by = null;
    this.created_on = DateTime.create().format('Y-M-d H:M:S');
    this.modified_by = null;
    this.modified_on = null;
    this.app_name = null;
    this.currency = null;
    this.cost = null;
    this.expiry_time = null;
    this.notes = null;
    this.sender_id = null;
  }
}

class GenericTransactionalMail{
  constructor(){
    this.generic_transactional_mail_id = null;
    this.from_name = null;
    this.from_address = null;
    this.to_address = null;
    this.cc = null;
    this.bcc = null;
    this.subject = null;
    this.body = null;
    this.date = parseInt(((+new Date)/1000).toString());
    this.attachments = null;
    this.email_type = null;
    this.created_by = null;
    this.created_on = DateTime.create().format('Y-M-d H:M:S');
    this.modified_by = null;
    this.modified_on = null;
    this.delivery_status = null;
    this.email_provider = null;
    this.message_id = null;
    this.smtp_reply = null;
    this.open_time = null;
    this.open_bounce_data = null;
    this.unsubscribe_data = null;
    this.spam_data = null;
    this.hash = null;
    this.plaintext = null;
    this.app_name = null;
    this.to_name = null;
    this.mail_type = null;
    this.attempt = null;
    this.reply_to = null;
    this.reference_id = null;
    this.reference_type = null;
    this.expiry_time = null;
  }
}

class GenericPromotionalSms{
  constructor(){
    this.id = null;
    this.reference_id = null;
    this.reference_type = null;
    this.name = null;
    this.mobile = null;
    this.message_text = null;
    this.message_type = null;
    this.delivery_time = null;
    this.status = null;
    this.failure_reason = null;
    this.attempt = null;
    this.operator = null;
    this.operator_reply = null;
    this.operator_code = null;
    this.created_by = null;
    this.created_on = DateTime.create().format('Y-M-d H:M:S');
    this.modified_by = null;
    this.modified_on = null;
    this.initiated_at = null;
    this.app_name = null;
    this.currency = null;
    this.cost = null;
    this.expiry_time = null;
    this.notes = null;
    this.sender_id = null;
  }
}

class GenericPromotionalMail{
  constructor(){
    this.generic_promotional_mail_id = null;
    this.from_name = null;
    this.from_address = null;
    this.to_address = null;
    this.cc = null;
    this.bcc = null;
    this.subject = null;
    this.body = null;
    this.date = int(time.time())
    this.attachments = null;
    this.email_type = null;
    this.created_by = null;
    this.created_at = DateTime.create().format('Y-M-d H:M:S');
    this.modified_by = null;
    this.modified_on = null;
    this.delivery_status = null;
    this.email_provider = null;
    this.message_id = null;
    this.smtp_reply = null;
    this.open_time = null;
    this.open_bounce_data = null;
    this.unsubscribe_data = null;
    this.spam_data = null;
    this.hash = null;
    this.plaintext = null;
    this.app_name = null;
    this.to_name = null;
    this.mail_type = null;
    this.attempt = null;
    this.reply_to = null;
    this.reference_id = null;
    this.reference_type = null;
    this.expiry_time = null;
  }
}

class Otp{
  constructor(){
    this.transaction_id = null;
    this.transaction_type = null;
    this.mobile = null;
    this.otp = null;
    this.initiated_at = DateTime.create().format('Y-M-d H:M:S');
    this.app_name = null;
    this.expiry_time = null;
    this.max_retry = null;
  }
}

class OtpSms{
  constructor(){
    this.id = null;
    this.reference_id = null;
    this.reference_type = null;
    this.name = null;
    this.mobile = null;
    this.template = null;
    this.otp = null;
    this.message_type = null;
    this.delivery_time = null;
    this.status = null;
    this.failure_reason = null;
    this.attempt = null;
    this.operator = null;
    this.operator_reply = null;
    this.operator_code = null;
    this.created_by = null;
    this.created_on = DateTime.create().format('Y-M-d H:M:S');
    this.modified_by = null;
    this.modified_on = null;
    this.app_name = null;
    this.currency = null;
    this.cost = null;
    this.expiry_time = null;
    this.notes = null;
    this.sender_id = null;
  }
}

class OtpCall{
  constructor(){
    this.id = null;
    this.reference_id = null;
    this.reference_type = null;
    this.name = null;
    this.mobile = null;
    this.message_text = null;
    this.otp = null;
    this.message_type = null;
    this.delivery_time = null;
    this.status = null;
    this.failure_reason = null;
    this.attempt = null;
    this.operator = null;
    this.operator_reply = null;
    this.operator_code = null;
    this.created_by = null;
    this.created_on = null;
    this.modified_by = null;
    this.modified_on = DateTime.create().format('Y-M-d H:M:S');
    this.app_name = null;
    this.currency = null;
    this.cost = null;
    this.expiry_time = null;
    this.notes = null;
  }
}

class Attachment{
  constructor(vals={}){
    this.name = vals.name;
    this.location = vals.location;
  }
}

class PushData {
    constructor() {
        this.title = '';
        this.body = '';
        this.sound = '';
        this.body_loc_args = '';
        this.body_loc_key = '';
        this.title_loc_key = '';
        this.title_loc_args = '';
        this.custom = {};
    }
}

class AndroidPushData extends PushData {
    constructor() {
        super();
        this.icon = '';
    }
}

class IosPushData extends PushData {
    constructor() {
        super();
        this.badge = '';
    }
}

class PushObj {
    constructor() {
        this.app_name = '';
        this.service = '';
        this.reference_id = '';
        this.reference_type = '';
        this.data = {};
        this.app_version = {};
        this.is_silent = undefined;
        this.last_active = {};
        this.account_id = '';
        this.is_content_available = undefined;
        this.device_id = '';
        this.push_type = '';
    }
}

class IosPushObj extends PushObj {
    constructor() {
        super();
        this.data = new IosPushData();
        this.is_silent = false;
        this.app_name = 'ios';
    }
}

class AndroidPushObj extends PushObj {
    constructor() {
        super();
        this.data = new AndroidPushData();
        this.is_silent = true;
        this.app_name = 'android';
    }
}

class PatientPromoAndroidPushObj extends AndroidPushObj {
    constructor() {
        super();
    }
}

class PatientTransAndroidPushObj extends AndroidPushObj {
    constructor() {
        super();
    }
}

class PatientPromoIosPushObj extends IosPushObj {
    constructor() {
        super();
    }
}

class PatientTransIosPushObj extends IosPushObj {
    constructor() {
        super();
    }
}

class PushDataTypes {
    constructor() {
        this.types = {
            'app_name': "string",
            'service': "string",
            'reference_id': "string",
            'reference_type': "string",
            'app_version': "object",
            'is_silent': "boolean",
            'last_active': "object",
            'account_id': "string",
            'is_content_available': "boolean",
            'device_id': "string",
            'data': "object"
        }
    }
}

module.exports = {
  GenericTransactionalSms: GenericTransactionalSms,
  GenericTransactionalMail: GenericTransactionalMail,
  GenericPromotionalSms: GenericPromotionalSms,
  GenericPromotionalMail: GenericPromotionalMail,
  Otp: Otp,
  OtpCall: OtpCall,
  OtpSms: OtpSms,
  Attachment: Attachment,
  PatientPromoAndroidPushObj: PatientPromoAndroidPushObj,
  PatientTransAndroidPushObj: PatientTransAndroidPushObj,
  PatientPromoIosPushObj: PatientPromoIosPushObj,
  PatientTransIosPushObj: PatientTransIosPushObj,
  PushDataTypes: PushDataTypes
};
